/**
 * Freqtrade API
 * No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)
 *
 * The version of the OpenAPI document: 2021.12-dev21
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 *
 */


import ApiClient from "../ApiClient";
import Balances from '../model/Balances';
import BlacklistPayload from '../model/BlacklistPayload';
import BlacklistResponse from '../model/BlacklistResponse';
import Count from '../model/Count';
import Daily from '../model/Daily';
import DeleteLockRequest from '../model/DeleteLockRequest';
import DeleteTrade from '../model/DeleteTrade';
import HTTPValidationError from '../model/HTTPValidationError';
import Locks from '../model/Locks';
import Logs from '../model/Logs';
import OpenTradeSchema from '../model/OpenTradeSchema';
import PerformanceEntry from '../model/PerformanceEntry';
import Profit from '../model/Profit';
import ShowConfig from '../model/ShowConfig';
import Stats from '../model/Stats';
import SysInfo from '../model/SysInfo';
import Version from '../model/Version';
import WhitelistResponse from '../model/WhitelistResponse';

/**
* Info service.
* @module ftclient/InfoApi
* @version 2021.12-dev21
*/
export default class InfoApi {

    /**
    * Constructs a new InfoApi. 
    * @alias module:ftclient/InfoApi
    * @class
    * @param {module:ApiClient} [apiClient] Optional API client implementation to use,
    * default to {@link module:ApiClient#instance} if unspecified.
    */
    constructor(apiClient) {
        this.apiClient = apiClient || ApiClient.instance;
    }



    /**
     * Balance
     * Account Balances
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with an object containing data of type {@link module:model/Balances} and HTTP response
     */
    balanceApiV1BalanceGetWithHttpInfo() {
      let postBody = null;

      let pathParams = {
      };
      let queryParams = {
      };
      let headerParams = {
      };
      let formParams = {
      };

      let authNames = ['HTTPBasic', 'OAuth2PasswordBearer'];
      let contentTypes = [];
      let accepts = ['application/json'];
      let returnType = Balances;
      return this.apiClient.callApi(
        '/api/v1/balance', 'GET',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, null
      );
    }

    /**
     * Balance
     * Account Balances
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with data of type {@link module:model/Balances}
     */
    balanceApiV1BalanceGet() {
      return this.balanceApiV1BalanceGetWithHttpInfo()
        .then(function(response_and_data) {
          return response_and_data.data;
        });
    }


    /**
     * Blacklist
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with an object containing data of type {@link module:model/BlacklistResponse} and HTTP response
     */
    blacklistApiV1BlacklistGetWithHttpInfo() {
      let postBody = null;

      let pathParams = {
      };
      let queryParams = {
      };
      let headerParams = {
      };
      let formParams = {
      };

      let authNames = ['HTTPBasic', 'OAuth2PasswordBearer'];
      let contentTypes = [];
      let accepts = ['application/json'];
      let returnType = BlacklistResponse;
      return this.apiClient.callApi(
        '/api/v1/blacklist', 'GET',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, null
      );
    }

    /**
     * Blacklist
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with data of type {@link module:model/BlacklistResponse}
     */
    blacklistApiV1BlacklistGet() {
      return this.blacklistApiV1BlacklistGetWithHttpInfo()
        .then(function(response_and_data) {
          return response_and_data.data;
        });
    }


    /**
     * Blacklist Delete
     * Provide a list of pairs to delete from the blacklist
     * @param {Object} opts Optional parameters
     * @param {Array.<String>} opts.pairsToDelete 
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with an object containing data of type {@link module:model/BlacklistResponse} and HTTP response
     */
    blacklistDeleteApiV1BlacklistDeleteWithHttpInfo(opts) {
      opts = opts || {};
      let postBody = null;

      let pathParams = {
      };
      let queryParams = {
        'pairs_to_delete': this.apiClient.buildCollectionParam(opts['pairsToDelete'], 'multi')
      };
      let headerParams = {
      };
      let formParams = {
      };

      let authNames = ['HTTPBasic', 'OAuth2PasswordBearer'];
      let contentTypes = [];
      let accepts = ['application/json'];
      let returnType = BlacklistResponse;
      return this.apiClient.callApi(
        '/api/v1/blacklist', 'DELETE',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, null
      );
    }

    /**
     * Blacklist Delete
     * Provide a list of pairs to delete from the blacklist
     * @param {Object} opts Optional parameters
     * @param {Array.<String>} opts.pairsToDelete 
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with data of type {@link module:model/BlacklistResponse}
     */
    blacklistDeleteApiV1BlacklistDelete(opts) {
      return this.blacklistDeleteApiV1BlacklistDeleteWithHttpInfo(opts)
        .then(function(response_and_data) {
          return response_and_data.data;
        });
    }


    /**
     * Blacklist Post
     * @param {module:model/BlacklistPayload} blacklistPayload 
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with an object containing data of type {@link module:model/BlacklistResponse} and HTTP response
     */
    blacklistPostApiV1BlacklistPostWithHttpInfo(blacklistPayload) {
      let postBody = blacklistPayload;
      // verify the required parameter 'blacklistPayload' is set
      if (blacklistPayload === undefined || blacklistPayload === null) {
        throw new Error("Missing the required parameter 'blacklistPayload' when calling blacklistPostApiV1BlacklistPost");
      }

      let pathParams = {
      };
      let queryParams = {
      };
      let headerParams = {
      };
      let formParams = {
      };

      let authNames = ['HTTPBasic', 'OAuth2PasswordBearer'];
      let contentTypes = ['application/json'];
      let accepts = ['application/json'];
      let returnType = BlacklistResponse;
      return this.apiClient.callApi(
        '/api/v1/blacklist', 'POST',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, null
      );
    }

    /**
     * Blacklist Post
     * @param {module:model/BlacklistPayload} blacklistPayload 
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with data of type {@link module:model/BlacklistResponse}
     */
    blacklistPostApiV1BlacklistPost(blacklistPayload) {
      return this.blacklistPostApiV1BlacklistPostWithHttpInfo(blacklistPayload)
        .then(function(response_and_data) {
          return response_and_data.data;
        });
    }


    /**
     * Count
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with an object containing data of type {@link module:model/Count} and HTTP response
     */
    countApiV1CountGetWithHttpInfo() {
      let postBody = null;

      let pathParams = {
      };
      let queryParams = {
      };
      let headerParams = {
      };
      let formParams = {
      };

      let authNames = ['HTTPBasic', 'OAuth2PasswordBearer'];
      let contentTypes = [];
      let accepts = ['application/json'];
      let returnType = Count;
      return this.apiClient.callApi(
        '/api/v1/count', 'GET',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, null
      );
    }

    /**
     * Count
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with data of type {@link module:model/Count}
     */
    countApiV1CountGet() {
      return this.countApiV1CountGetWithHttpInfo()
        .then(function(response_and_data) {
          return response_and_data.data;
        });
    }


    /**
     * Daily
     * @param {Object} opts Optional parameters
     * @param {Number} opts.timescale  (default to 7)
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with an object containing data of type {@link module:model/Daily} and HTTP response
     */
    dailyApiV1DailyGetWithHttpInfo(opts) {
      opts = opts || {};
      let postBody = null;

      let pathParams = {
      };
      let queryParams = {
        'timescale': opts['timescale']
      };
      let headerParams = {
      };
      let formParams = {
      };

      let authNames = ['HTTPBasic', 'OAuth2PasswordBearer'];
      let contentTypes = [];
      let accepts = ['application/json'];
      let returnType = Daily;
      return this.apiClient.callApi(
        '/api/v1/daily', 'GET',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, null
      );
    }

    /**
     * Daily
     * @param {Object} opts Optional parameters
     * @param {Number} opts.timescale  (default to 7)
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with data of type {@link module:model/Daily}
     */
    dailyApiV1DailyGet(opts) {
      return this.dailyApiV1DailyGetWithHttpInfo(opts)
        .then(function(response_and_data) {
          return response_and_data.data;
        });
    }


    /**
     * Delete Lock
     * @param {Number} lockid 
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with an object containing data of type {@link module:model/Locks} and HTTP response
     */
    deleteLockApiV1LocksLockidDeleteWithHttpInfo(lockid) {
      let postBody = null;
      // verify the required parameter 'lockid' is set
      if (lockid === undefined || lockid === null) {
        throw new Error("Missing the required parameter 'lockid' when calling deleteLockApiV1LocksLockidDelete");
      }

      let pathParams = {
        'lockid': lockid
      };
      let queryParams = {
      };
      let headerParams = {
      };
      let formParams = {
      };

      let authNames = ['HTTPBasic', 'OAuth2PasswordBearer'];
      let contentTypes = [];
      let accepts = ['application/json'];
      let returnType = Locks;
      return this.apiClient.callApi(
        '/api/v1/locks/{lockid}', 'DELETE',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, null
      );
    }

    /**
     * Delete Lock
     * @param {Number} lockid 
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with data of type {@link module:model/Locks}
     */
    deleteLockApiV1LocksLockidDelete(lockid) {
      return this.deleteLockApiV1LocksLockidDeleteWithHttpInfo(lockid)
        .then(function(response_and_data) {
          return response_and_data.data;
        });
    }


    /**
     * Delete Lock Pair
     * @param {module:model/DeleteLockRequest} deleteLockRequest 
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with an object containing data of type {@link module:model/Locks} and HTTP response
     */
    deleteLockPairApiV1LocksDeletePostWithHttpInfo(deleteLockRequest) {
      let postBody = deleteLockRequest;
      // verify the required parameter 'deleteLockRequest' is set
      if (deleteLockRequest === undefined || deleteLockRequest === null) {
        throw new Error("Missing the required parameter 'deleteLockRequest' when calling deleteLockPairApiV1LocksDeletePost");
      }

      let pathParams = {
      };
      let queryParams = {
      };
      let headerParams = {
      };
      let formParams = {
      };

      let authNames = ['HTTPBasic', 'OAuth2PasswordBearer'];
      let contentTypes = ['application/json'];
      let accepts = ['application/json'];
      let returnType = Locks;
      return this.apiClient.callApi(
        '/api/v1/locks/delete', 'POST',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, null
      );
    }

    /**
     * Delete Lock Pair
     * @param {module:model/DeleteLockRequest} deleteLockRequest 
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with data of type {@link module:model/Locks}
     */
    deleteLockPairApiV1LocksDeletePost(deleteLockRequest) {
      return this.deleteLockPairApiV1LocksDeletePostWithHttpInfo(deleteLockRequest)
        .then(function(response_and_data) {
          return response_and_data.data;
        });
    }


    /**
     * Edge
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with an object containing data of type {@link Object} and HTTP response
     */
    edgeApiV1EdgeGetWithHttpInfo() {
      let postBody = null;

      let pathParams = {
      };
      let queryParams = {
      };
      let headerParams = {
      };
      let formParams = {
      };

      let authNames = ['HTTPBasic', 'OAuth2PasswordBearer'];
      let contentTypes = [];
      let accepts = ['application/json'];
      let returnType = Object;
      return this.apiClient.callApi(
        '/api/v1/edge', 'GET',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, null
      );
    }

    /**
     * Edge
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with data of type {@link Object}
     */
    edgeApiV1EdgeGet() {
      return this.edgeApiV1EdgeGetWithHttpInfo()
        .then(function(response_and_data) {
          return response_and_data.data;
        });
    }


    /**
     * Locks
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with an object containing data of type {@link module:model/Locks} and HTTP response
     */
    locksApiV1LocksGetWithHttpInfo() {
      let postBody = null;

      let pathParams = {
      };
      let queryParams = {
      };
      let headerParams = {
      };
      let formParams = {
      };

      let authNames = ['HTTPBasic', 'OAuth2PasswordBearer'];
      let contentTypes = [];
      let accepts = ['application/json'];
      let returnType = Locks;
      return this.apiClient.callApi(
        '/api/v1/locks', 'GET',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, null
      );
    }

    /**
     * Locks
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with data of type {@link module:model/Locks}
     */
    locksApiV1LocksGet() {
      return this.locksApiV1LocksGetWithHttpInfo()
        .then(function(response_and_data) {
          return response_and_data.data;
        });
    }


    /**
     * Logs
     * @param {Object} opts Optional parameters
     * @param {Number} opts.limit 
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with an object containing data of type {@link module:model/Logs} and HTTP response
     */
    logsApiV1LogsGetWithHttpInfo(opts) {
      opts = opts || {};
      let postBody = null;

      let pathParams = {
      };
      let queryParams = {
        'limit': opts['limit']
      };
      let headerParams = {
      };
      let formParams = {
      };

      let authNames = ['HTTPBasic', 'OAuth2PasswordBearer'];
      let contentTypes = [];
      let accepts = ['application/json'];
      let returnType = Logs;
      return this.apiClient.callApi(
        '/api/v1/logs', 'GET',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, null
      );
    }

    /**
     * Logs
     * @param {Object} opts Optional parameters
     * @param {Number} opts.limit 
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with data of type {@link module:model/Logs}
     */
    logsApiV1LogsGet(opts) {
      return this.logsApiV1LogsGetWithHttpInfo(opts)
        .then(function(response_and_data) {
          return response_and_data.data;
        });
    }


    /**
     * Performance
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with an object containing data of type {@link Array.<module:model/PerformanceEntry>} and HTTP response
     */
    performanceApiV1PerformanceGetWithHttpInfo() {
      let postBody = null;

      let pathParams = {
      };
      let queryParams = {
      };
      let headerParams = {
      };
      let formParams = {
      };

      let authNames = ['HTTPBasic', 'OAuth2PasswordBearer'];
      let contentTypes = [];
      let accepts = ['application/json'];
      let returnType = [PerformanceEntry];
      return this.apiClient.callApi(
        '/api/v1/performance', 'GET',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, null
      );
    }

    /**
     * Performance
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with data of type {@link Array.<module:model/PerformanceEntry>}
     */
    performanceApiV1PerformanceGet() {
      return this.performanceApiV1PerformanceGetWithHttpInfo()
        .then(function(response_and_data) {
          return response_and_data.data;
        });
    }


    /**
     * Profit
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with an object containing data of type {@link module:model/Profit} and HTTP response
     */
    profitApiV1ProfitGetWithHttpInfo() {
      let postBody = null;

      let pathParams = {
      };
      let queryParams = {
      };
      let headerParams = {
      };
      let formParams = {
      };

      let authNames = ['HTTPBasic', 'OAuth2PasswordBearer'];
      let contentTypes = [];
      let accepts = ['application/json'];
      let returnType = Profit;
      return this.apiClient.callApi(
        '/api/v1/profit', 'GET',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, null
      );
    }

    /**
     * Profit
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with data of type {@link module:model/Profit}
     */
    profitApiV1ProfitGet() {
      return this.profitApiV1ProfitGetWithHttpInfo()
        .then(function(response_and_data) {
          return response_and_data.data;
        });
    }


    /**
     * Show Config
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with an object containing data of type {@link module:model/ShowConfig} and HTTP response
     */
    showConfigApiV1ShowConfigGetWithHttpInfo() {
      let postBody = null;

      let pathParams = {
      };
      let queryParams = {
      };
      let headerParams = {
      };
      let formParams = {
      };

      let authNames = ['HTTPBasic', 'OAuth2PasswordBearer'];
      let contentTypes = [];
      let accepts = ['application/json'];
      let returnType = ShowConfig;
      return this.apiClient.callApi(
        '/api/v1/show_config', 'GET',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, null
      );
    }

    /**
     * Show Config
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with data of type {@link module:model/ShowConfig}
     */
    showConfigApiV1ShowConfigGet() {
      return this.showConfigApiV1ShowConfigGetWithHttpInfo()
        .then(function(response_and_data) {
          return response_and_data.data;
        });
    }


    /**
     * Stats
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with an object containing data of type {@link module:model/Stats} and HTTP response
     */
    statsApiV1StatsGetWithHttpInfo() {
      let postBody = null;

      let pathParams = {
      };
      let queryParams = {
      };
      let headerParams = {
      };
      let formParams = {
      };

      let authNames = ['HTTPBasic', 'OAuth2PasswordBearer'];
      let contentTypes = [];
      let accepts = ['application/json'];
      let returnType = Stats;
      return this.apiClient.callApi(
        '/api/v1/stats', 'GET',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, null
      );
    }

    /**
     * Stats
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with data of type {@link module:model/Stats}
     */
    statsApiV1StatsGet() {
      return this.statsApiV1StatsGetWithHttpInfo()
        .then(function(response_and_data) {
          return response_and_data.data;
        });
    }


    /**
     * Status
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with an object containing data of type {@link Array.<module:model/OpenTradeSchema>} and HTTP response
     */
    statusApiV1StatusGetWithHttpInfo() {
      let postBody = null;

      let pathParams = {
      };
      let queryParams = {
      };
      let headerParams = {
      };
      let formParams = {
      };

      let authNames = ['HTTPBasic', 'OAuth2PasswordBearer'];
      let contentTypes = [];
      let accepts = ['application/json'];
      let returnType = [OpenTradeSchema];
      return this.apiClient.callApi(
        '/api/v1/status', 'GET',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, null
      );
    }

    /**
     * Status
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with data of type {@link Array.<module:model/OpenTradeSchema>}
     */
    statusApiV1StatusGet() {
      return this.statusApiV1StatusGetWithHttpInfo()
        .then(function(response_and_data) {
          return response_and_data.data;
        });
    }


    /**
     * Sysinfo
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with an object containing data of type {@link module:model/SysInfo} and HTTP response
     */
    sysinfoApiV1SysinfoGetWithHttpInfo() {
      let postBody = null;

      let pathParams = {
      };
      let queryParams = {
      };
      let headerParams = {
      };
      let formParams = {
      };

      let authNames = ['HTTPBasic', 'OAuth2PasswordBearer'];
      let contentTypes = [];
      let accepts = ['application/json'];
      let returnType = SysInfo;
      return this.apiClient.callApi(
        '/api/v1/sysinfo', 'GET',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, null
      );
    }

    /**
     * Sysinfo
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with data of type {@link module:model/SysInfo}
     */
    sysinfoApiV1SysinfoGet() {
      return this.sysinfoApiV1SysinfoGetWithHttpInfo()
        .then(function(response_and_data) {
          return response_and_data.data;
        });
    }


    /**
     * Trade
     * @param {Number} tradeid 
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with an object containing data of type {@link module:model/OpenTradeSchema} and HTTP response
     */
    tradeApiV1TradeTradeidGetWithHttpInfo(tradeid) {
      let postBody = null;
      // verify the required parameter 'tradeid' is set
      if (tradeid === undefined || tradeid === null) {
        throw new Error("Missing the required parameter 'tradeid' when calling tradeApiV1TradeTradeidGet");
      }

      let pathParams = {
        'tradeid': tradeid
      };
      let queryParams = {
      };
      let headerParams = {
      };
      let formParams = {
      };

      let authNames = ['HTTPBasic', 'OAuth2PasswordBearer'];
      let contentTypes = [];
      let accepts = ['application/json'];
      let returnType = OpenTradeSchema;
      return this.apiClient.callApi(
        '/api/v1/trade/{tradeid}', 'GET',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, null
      );
    }

    /**
     * Trade
     * @param {Number} tradeid 
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with data of type {@link module:model/OpenTradeSchema}
     */
    tradeApiV1TradeTradeidGet(tradeid) {
      return this.tradeApiV1TradeTradeidGetWithHttpInfo(tradeid)
        .then(function(response_and_data) {
          return response_and_data.data;
        });
    }


    /**
     * Trades
     * @param {Object} opts Optional parameters
     * @param {Number} opts.limit  (default to 500)
     * @param {Number} opts.offset  (default to 0)
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with an object containing data of type {@link Object} and HTTP response
     */
    tradesApiV1TradesGetWithHttpInfo(opts) {
      opts = opts || {};
      let postBody = null;

      let pathParams = {
      };
      let queryParams = {
        'limit': opts['limit'],
        'offset': opts['offset']
      };
      let headerParams = {
      };
      let formParams = {
      };

      let authNames = ['HTTPBasic', 'OAuth2PasswordBearer'];
      let contentTypes = [];
      let accepts = ['application/json'];
      let returnType = Object;
      return this.apiClient.callApi(
        '/api/v1/trades', 'GET',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, null
      );
    }

    /**
     * Trades
     * @param {Object} opts Optional parameters
     * @param {Number} opts.limit  (default to 500)
     * @param {Number} opts.offset  (default to 0)
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with data of type {@link Object}
     */
    tradesApiV1TradesGet(opts) {
      return this.tradesApiV1TradesGetWithHttpInfo(opts)
        .then(function(response_and_data) {
          return response_and_data.data;
        });
    }


    /**
     * Trades Delete
     * @param {Number} tradeid 
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with an object containing data of type {@link module:model/DeleteTrade} and HTTP response
     */
    tradesDeleteApiV1TradesTradeidDeleteWithHttpInfo(tradeid) {
      let postBody = null;
      // verify the required parameter 'tradeid' is set
      if (tradeid === undefined || tradeid === null) {
        throw new Error("Missing the required parameter 'tradeid' when calling tradesDeleteApiV1TradesTradeidDelete");
      }

      let pathParams = {
        'tradeid': tradeid
      };
      let queryParams = {
      };
      let headerParams = {
      };
      let formParams = {
      };

      let authNames = ['HTTPBasic', 'OAuth2PasswordBearer'];
      let contentTypes = [];
      let accepts = ['application/json'];
      let returnType = DeleteTrade;
      return this.apiClient.callApi(
        '/api/v1/trades/{tradeid}', 'DELETE',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, null
      );
    }

    /**
     * Trades Delete
     * @param {Number} tradeid 
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with data of type {@link module:model/DeleteTrade}
     */
    tradesDeleteApiV1TradesTradeidDelete(tradeid) {
      return this.tradesDeleteApiV1TradesTradeidDeleteWithHttpInfo(tradeid)
        .then(function(response_and_data) {
          return response_and_data.data;
        });
    }


    /**
     * Version
     * Bot Version info
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with an object containing data of type {@link module:model/Version} and HTTP response
     */
    versionApiV1VersionGetWithHttpInfo() {
      let postBody = null;

      let pathParams = {
      };
      let queryParams = {
      };
      let headerParams = {
      };
      let formParams = {
      };

      let authNames = ['HTTPBasic', 'OAuth2PasswordBearer'];
      let contentTypes = [];
      let accepts = ['application/json'];
      let returnType = Version;
      return this.apiClient.callApi(
        '/api/v1/version', 'GET',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, null
      );
    }

    /**
     * Version
     * Bot Version info
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with data of type {@link module:model/Version}
     */
    versionApiV1VersionGet() {
      return this.versionApiV1VersionGetWithHttpInfo()
        .then(function(response_and_data) {
          return response_and_data.data;
        });
    }


    /**
     * Whitelist
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with an object containing data of type {@link module:model/WhitelistResponse} and HTTP response
     */
    whitelistApiV1WhitelistGetWithHttpInfo() {
      let postBody = null;

      let pathParams = {
      };
      let queryParams = {
      };
      let headerParams = {
      };
      let formParams = {
      };

      let authNames = ['HTTPBasic', 'OAuth2PasswordBearer'];
      let contentTypes = [];
      let accepts = ['application/json'];
      let returnType = WhitelistResponse;
      return this.apiClient.callApi(
        '/api/v1/whitelist', 'GET',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, null
      );
    }

    /**
     * Whitelist
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with data of type {@link module:model/WhitelistResponse}
     */
    whitelistApiV1WhitelistGet() {
      return this.whitelistApiV1WhitelistGetWithHttpInfo()
        .then(function(response_and_data) {
          return response_and_data.data;
        });
    }


}
